/*This code Written by Ashok Kumar Kumawat
 *Date 03/12/16
 *xshokkuamr23@gmail.com
 *xshokkumar@gmail.com
 *www.technocrat.tech.blog
 */

#include<EEPROM.h>
#include<IRremote.h>
int RECV_PIN = 11;                     // Pin 11 is receive IR receiver signal
int relay_1 = 9;
int relay_2 = 8;
int relay_3 = 7;
int relay_state[] = {0, 0, 0, 0};
int address = 0;
byte value1, value2, value3;

// Put your Remote Raw values in code1, code2, code3
// like 0X.......

#define code1 0XE0E020DF
#define code2 0XE0E0A05F
#define code3 0XE0E0609F
IRrecv irrecv(RECV_PIN);
decode_results results;
void setup() {
  Serial.begin(9600);
  irrecv.enableIRIn();
  pinMode(relay_1, OUTPUT);
  pinMode(relay_2, OUTPUT);
  pinMode(relay_3, OUTPUT);


}

void loop() {

  value1 = EEPROM.read(1);
  value2 = EEPROM.read(2);
  value3 = EEPROM.read(3);


  Serial.print(value1);
  Serial.print("     ");
  Serial.print(value2);
  Serial.print("     ");
  Serial.println(value3);
  

  if (value1 == 1) {
    digitalWrite(relay_1, HIGH);
  }
  else {
    digitalWrite(relay_1, LOW);
  }
  if (value2 == 1) {
    digitalWrite(relay_2, HIGH);
  }
  else {
    digitalWrite(relay_2, LOW);
  }
  if (value3 == 1) {
    digitalWrite(relay_3, HIGH);
  }
  else {
    digitalWrite(relay_3, LOW);
  }
  if (irrecv.decode(&results)) {
    unsigned int value = results.value;
    switch (value) {
      case code1: {
          if (relay_state[1] == 1) {
            Serial.println("Relay 1 = OFF");
            relay_state[1] = 0;
          }
          else {
            Serial.println("Relay 1 = ON");
            relay_state[1] = 1;
          }
          EEPROM.write(1, relay_state[1]);
          Serial.print(value1, DEC);
          Serial.println();
          break;
        }
      case code2: {
          if (relay_state[2] == 1) {
            Serial.println("Relay 2 = OFF");
            relay_state[2] = 0;
          }
          else {
            Serial.println("Relay 2 = ON");
            relay_state[2] = 1;
          }
          EEPROM.write(2, relay_state[2]);
          Serial.print(value2, DEC);
          Serial.println();
          break;
        }
      case code3: {
          if (relay_state[3] == 1) {
            Serial.println("Relay 3 = OFF");
            relay_state[3] = 0;
          }
          else {
            Serial.println("Relay 3 = ON");
            relay_state[3] = 1;
          }
          EEPROM.write(3, relay_state[3]);
          Serial.print(value3, DEC);
          Serial.println();
        }
    }
    irrecv.resume();
  }
}

